linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: Andrew Vagin <avagin@openvz.org>
To: linux-kernel@vger.kernel.org
Cc: a.p.zijlstra@chello.nl, paulus@samba.org, mingo@elte.hu,
	acme@ghostprotocols.net, asharma@fb.com, devel@openvz.org,
	dsahern@gmail.com, linux-perf-users@vger.kernel.org
Subject: [PATCH 6/7] perf: add scripts for profiling sleep times (v2)
Date: Mon, 28 Nov 2011 12:03:34 +0300	[thread overview]
Message-ID: <1322471015-107825-7-git-send-email-avagin@openvz.org> (raw)
In-Reply-To: <1322471015-107825-1-git-send-email-avagin@openvz.org>

E.g.:
 # perf script record -- sched:sched_stat_sleep -- ./foo
 # perf script report sched-stat
or
 # perf script record -- -e sched:sched_stat_sleep

v2: Add ability to record events for a defined process. It executes a small
bash script, then executes perf with filtering by pid and then a bash script
executes a target process.

Signed-off-by: Andrew Vagin <avagin@openvz.org>
---
 tools/perf/scripts/python/bin/sched-stat-record |   65 +++++++++++++++++++++++
 tools/perf/scripts/python/bin/sched-stat-report |    5 ++
 2 files changed, 70 insertions(+), 0 deletions(-)
 create mode 100644 tools/perf/scripts/python/bin/sched-stat-record
 create mode 100644 tools/perf/scripts/python/bin/sched-stat-report

diff --git a/tools/perf/scripts/python/bin/sched-stat-record b/tools/perf/scripts/python/bin/sched-stat-record
new file mode 100644
index 0000000..5e0bd97
--- /dev/null
+++ b/tools/perf/scripts/python/bin/sched-stat-record
@@ -0,0 +1,65 @@
+#!/bin/bash
+# perf script record -- sched:sched_stat_[smth] -- CMD
+# perf script record -- -e sched:sched_stat_[smth]
+#
+set -o monitor
+
+usage()
+{
+	echo "Usage:"
+	echo "	perf script record -- sched:sched_stat_[smth] -- CMD"
+	echo "	perf script record -- [PERF OPTS] -e sched:sched_stat_[smth]"
+	exit 1;
+}
+
+declare -a opt
+declare -a cmd
+f=0;
+for i in "${@:2}"; do
+	if [ "$i" == "--" ]; then
+		f=1
+		continue
+	fi
+	if [ $f -eq 1 ]; then
+		cmd[${#cmd[*]}]="$i"
+	else
+		opt[${#opt[*]}]="$i"
+	fi
+done
+
+if [[ "${opt[@]}" != *sched_stat_* ]]; then
+	usage;
+fi
+
+if [ ${#cmd[@]} -eq 0 ]; then
+	if [ ${#opt[@]} -eq 0 ]; then
+		usage;
+	fi
+	exec perf record -agP \
+		-e sched:sched_switch \
+		--filter "prev_state == 1 || prev_state == 2" \
+		"${opt[@]}"
+fi
+
+if [ ${#opt[@]} -ne 1 ]; then
+	usage;
+fi
+
+# Wait until a target process is stopped.
+bash -c 'kill -STOP $$; exec "$@"' -- "${cmd[@]}" &
+pid=$!
+wait %1
+[ $? -eq 147 ] || exit 1;
+
+perf record -agP \
+		-e sched:sched_switch \
+		--filter "prev_pid == $pid && prev_state == 1 || prev_state == 2" \
+		-e sched:sched_process_exit -e "${opt[@]}" --filter "pid == $pid" &
+pid_perf=$!
+kill -CONT %1
+while :; do
+	wait %1
+	[ $? -eq 127 ] && break;
+done
+kill -INT %2
+wait %2
diff --git a/tools/perf/scripts/python/bin/sched-stat-report b/tools/perf/scripts/python/bin/sched-stat-report
new file mode 100644
index 0000000..e5114ce
--- /dev/null
+++ b/tools/perf/scripts/python/bin/sched-stat-report
@@ -0,0 +1,5 @@
+#!/bin/bash
+# description: profiling sleep times
+perf inject -s -i perf.data -o perf.data.d || exit
+perf report -i perf.data.d || exit
+unlink perf.data.d
-- 
1.7.1


  parent reply	other threads:[~2011-11-28  9:06 UTC|newest]

Thread overview: 25+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2011-11-28  9:03 [PATCH 0/7] Profiling sleep times (v3) Andrew Vagin
2011-11-28  9:03 ` [PATCH 1/7] perf: use event_name() to get an event name Andrew Vagin
2011-12-06 14:02   ` Arnaldo Carvalho de Melo
2011-12-08  4:34   ` [tip:perf/urgent] perf header: Use " tip-bot for Andrew Vagin
2011-11-28  9:03 ` [PATCH 2/7] perf: add ability to record event period Andrew Vagin
2011-12-06 14:02   ` Arnaldo Carvalho de Melo
2011-11-28  9:03 ` [PATCH 3/7] perf: add ability to change event according to sample (v2) Andrew Vagin
2011-12-06 14:19   ` Arnaldo Carvalho de Melo
2011-12-06 14:24     ` Arnaldo Carvalho de Melo
2011-12-06 14:57     ` David Ahern
2011-12-06 15:06       ` Arnaldo Carvalho de Melo
2011-11-28  9:03 ` [PATCH 4/7] perf: teach "perf inject" to work with files Andrew Vagin
2011-11-28  9:03 ` [PATCH 5/7] perf: teach perf inject to merge sched_stat_* and sched_switch events Andrew Vagin
2011-11-28  9:03 ` Andrew Vagin [this message]
2011-11-28  9:03 ` [PATCH 7/7] event: add tracepoint for accounting block time Andrew Vagin
2011-11-28 11:42   ` Peter Zijlstra
2011-11-28 14:02     ` Arjan van de Ven
2011-11-28 14:31       ` Arnaldo Carvalho de Melo
2011-11-28 14:43         ` Arjan van de Ven
2011-11-28 14:59           ` Arnaldo Carvalho de Melo
2011-12-06  9:48   ` [tip:sched/core] events, sched: Add tracepoint for accounting blocked time tip-bot for Andrew Vagin
2011-12-06  7:15 ` [Devel] [PATCH 0/7] Profiling sleep times (v3) Andrey Vagin
2011-12-06  8:30   ` Ingo Molnar
2011-12-06 13:45   ` Arnaldo Carvalho de Melo
2011-12-07 20:33   ` Arun Sharma

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1322471015-107825-7-git-send-email-avagin@openvz.org \
    --to=avagin@openvz.org \
    --cc=a.p.zijlstra@chello.nl \
    --cc=acme@ghostprotocols.net \
    --cc=asharma@fb.com \
    --cc=devel@openvz.org \
    --cc=dsahern@gmail.com \
    --cc=linux-kernel@vger.kernel.org \
    --cc=linux-perf-users@vger.kernel.org \
    --cc=mingo@elte.hu \
    --cc=paulus@samba.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).